/*									TPFH Ralit virtuelle								*
 *											(ESIEA)										*
 ****************************************************************************************/
#include <windows.h>					// En-tte standart aux prog. Windows
#include <gl\gl.h>						// fonctions OpenGL
#include <gl\glaux.h>					// Librairie AUX
#include <math.h>
#include <stdio.h>

#define LARGEUR 500
#define HAUTEUR 500

GLint cube = 0;

void drawFloor()
{
		glColor4f(0.5f, 0.5f, 0.5f, 0.75f);
		glBegin(GL_QUADS);
			  glVertex3f(-4.0,  4.0, 0.0);
			  glVertex3f( 4.0,  4.0, 0.0);
			  glVertex3f( 4.0, -4.0, 0.0);
			  glVertex3f(-4.0, -4.0, 0.0);
		glEnd();
}

void SetLight()
{
        GLfloat ambientProperties[] = {0.7f, 0.7f, 0.7f, 1.0f};
        GLfloat diffuseProperties[] = {1.0f, 1.0f, 1.0f, 1.0f};
        GLfloat positionProperties[] = {5.0f, 0.0f, 0.0f, 0.0f};
        glLightfv( GL_LIGHT0, GL_AMBIENT, ambientProperties);
        glLightfv( GL_LIGHT0, GL_DIFFUSE, diffuseProperties);
        glLightfv( GL_LIGHT0, GL_POSITION, positionProperties);
        glEnable(GL_LIGHT0);
        glEnable(GL_LIGHTING);
}

void CALLBACK Main_part(void)
{
        GLfloat Rouge[] = {0.8f, 0.0f, 0.0f, 1.0f};
        GLfloat Vert[]  = {0.0f, 0.8f, 0.0f, 1.0f};
        GLfloat Bleu[]  = {0.0f, 0.0f, 0.8f, 1.0f};

    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
        

        drawFloor();
        glPushMatrix();
               glTranslatef(0.0f, -2.0f, 5.0f);
               glRotatef((80.0f), -0.5f, 0.3f, -0.8f);
               glRotatef((10.0f), 0.5f, -0.3f, 0.8f);
               glCallList(cube);
        glPopMatrix();
		auxSwapBuffers();
}

void init()
{
		GLfloat	Blanc[]  = {1.0f, 1.0f, 1.0f, 1.0f};

			//Taille = 128 * 128. RGB 3 octets
        char buffer[128*128*3];
        FILE *f = fopen("herbe.raw", "rb");
        if (f)
        {
                   fread(buffer, 128*128*3, 1, f);
                   fclose(f);
				   printf("texture charge");
						//On spcifie qu'elle texture, sa taille, son type ...
                   glTexImage2D(GL_TEXTURE_2D,0,3, 128, 128, 0, GL_RGB, GL_UNSIGNED_BYTE, buffer);
						//cela dfinit la faon dont la texture est applique. LINEAR est le meilleur, mais le + lent.
                   glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
                   glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
						//On rpte la texture si s et t sortent des bornes [0,1]
				   glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
				   glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
						//ouf, ca y est !!!
                   glEnable(GL_TEXTURE_2D);
        }else printf("Il y a un problme de fichier!!!!\n");        

		cube = glGenLists(1);
		glNewList(cube, GL_COMPILE);
			glBegin(GL_QUADS);
			   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, Blanc);
			   glNormal3d(0.0,0.0,1.0);
					//on spcifie la position des pingles (on tourne : une seule coordonne change  la fois)
			   glTexCoord2d(0,0);glVertex3d(-1,  1, 1);
			   glTexCoord2d(0,1);glVertex3d(-1, -1, 1);
			   glTexCoord2d(1,1);glVertex3d( 1, -1, 1);
			   glTexCoord2d(1,0);glVertex3d( 1,  1, 1);
			   glNormal3d(-1.0,0.0,0.0);
					//idem
			   glTexCoord2d(0,0);glVertex3d( -1,  1,  1);
			   glTexCoord2d(0,1);glVertex3d( -1,  1, -1);
			   glTexCoord2d(1,1);glVertex3d( -1, -1, -1);
			   glTexCoord2d(1,0);glVertex3d( -1, -1,  1);
					//idem
			   glNormal3d(1.0,0.0,0.0);
			   glTexCoord2d(0,0);glVertex3d( 1,  1,  1);
			   glTexCoord2d(0,1);glVertex3d( 1, -1,  1);
			   glTexCoord2d(1,1);glVertex3d( 1, -1, -1);
			   glTexCoord2d(1,0);glVertex3d( 1,  1, -1);
			   glNormal3d(0.0,1.0,0.0);
					//idem
			   glTexCoord2d(0,0);glVertex3d( -1, 1,  1);
			   glTexCoord2d(0,1);glVertex3d(  1, 1,  1);
			   glTexCoord2d(1,1);glVertex3d(  1, 1, -1);
			   glTexCoord2d(1,0);glVertex3d( -1, 1, -1);
			   glNormal3d(0.0,-1.0,0.0);
					//idem
			   glTexCoord2d(0,0);glVertex3d( -1, -1,  1);
			   glTexCoord2d(0,1);glVertex3d( -1, -1, -1);
			   glTexCoord2d(1,1);glVertex3d(  1, -1, -1);
			   glTexCoord2d(1,0);glVertex3d(  1, -1,  1);
			   glNormal3d(0.0,0.0,-1.0);
					//idem
			   glTexCoord2d(0,0);glVertex3d(  1,  1, -1);
			   glTexCoord2d(1,0);glVertex3d(  1, -1, -1);
			   glTexCoord2d(1,1);glVertex3d( -1, -1, -1);
			   glTexCoord2d(0,1);glVertex3d( -1,  1, -1);		   
			glEnd();
		glEndList();
}

void CALLBACK reshape (int width, int height)
{
      glViewport (0, 0, width, height);
      glMatrixMode (GL_PROJECTION);
      glLoadIdentity ();
	  gluPerspective (45.0, ((GLfloat) width) / ((GLfloat) height),1.0,100.0);
      glMatrixMode (GL_MODELVIEW);
      glLoadIdentity ();
      gluLookAt (0.0,-7.0,15.0, 0.0, 0.0, 0.0,0.0,0.0, 1.0);
      glEnable(GL_DEPTH_TEST);
      glEnable(GL_POLYGON_SMOOTH);
      SetLight();
}

int main (int argc, char *argv[])
{
		auxInitDisplayMode(AUX_DOUBLE | AUX_RGBA | AUX_DEPTH | AUX_STENCIL);
		auxInitPosition(100,100,LARGEUR,HAUTEUR); 
		auxInitWindow("Textures");
		auxReshapeFunc(reshape);
		init();
		auxMainLoop(Main_part);
		return 0;
}
